#include <QUdpSocket>
#include <QTimer>
#include <QBuffer>
#include <QSettings>
#include "config.h"
#include "hiqsdr.h"
#include "display_base.h"
#ifdef UNIX
#include "keyreader.h"
#include "audio.h"
#endif
#ifdef ANDROID 
#include "audioQt.h"
#endif
#ifdef WIN32
#include "audio_win32.h"
#endif

class Control : public QObject  {
	Q_OBJECT
	public:
		Control(char*, char*, char*, char* ,char*, int);
		~Control();


	public slots:
		void controlCommand(int, int, int, bool inital=false);
		void readHamLibUDPData();
		void readHpsdrUDPData();


	signals:
		void displaySet(int,int,int);

	private slots:
		void timeout();
		void readSettings();
		void writeSettings();
		void audioRXRaw(QByteArray);

	private:
		void setMode();
		void restoreFilter();

		QTimer *timer;
		QString hiqsdrIP;
		QUdpSocket *hamLibSocket;
		QUdpSocket *hpsdrSocket;
		Hiqsdr *sdr;
#ifdef UNIX
		//KeyReader *keyReader;
#endif
		Audio *audio;
		firdes *fir;
		Display_base *disp;

		QSettings *settings;
		int config[CMD_LAST];

		QHostAddress sender;
		quint16 senderPort;
		uint8_t hpRxBuf[1200];
		int hpRxBufPos;
		uint8_t c[6];
		int txChanged;

		int hp_receivers;
		int cCnt;
		bool initReady;
};
