#include <QDebug>
#include <math.h>
#include <assert.h>
#include "config.h"
#include "display_touch.h"
#include "ui_display_touch.h"
#include "lib.h"

#define DOWN	yp += ys + GRID_SIZE;
#define UP  	yp -= ys + GRID_SIZE;
#define RIGHT 	xp += xs + GRID_SIZE;
#define LEFT  	xp -= xs + GRID_SIZE;

#define DOWN2	yp += ys + GRID_SIZE/2;
#define UP2  	yp -= ys + GRID_SIZE/2;
#define RIGHT2 	xp += xs + GRID_SIZE/2;
#define LEFT2  	xp -= xs + GRID_SIZE/2;

#define MAX_SHORT 		0x8000
#define NEW_BUTTON(...) button[bIdx++] = {NULL, QStringList(), {},  __VA_ARGS__ ,xp,yp,xs,ys}
#define NEW_ANALOG(...) analog[aIdx++] = {NULL, __VA_ARGS__ ,xp,yp,xs,ys}
#define NEW_LABEL(...)  label[lIdx++] =  {NULL, __VA_ARGS__ ,0,xp,yp,xs,ys}


extern bool touchscreen;
extern bool defaults;
extern int layOut;

extern MenuEntry menuMain[MAX_MENU];
extern MenuEntry menuMain1[MAX_MENU];
extern MenuEntry menuAnt[MAX_MENU];
extern MenuEntry menuFreq[MAX_MENU];
extern MenuEntry menuMode[MAX_MENU];
extern MenuEntry menuDisplay[MAX_MENU];
extern MenuEntry menuAtt[MAX_MENU];
extern MenuEntry menuStep[MAX_MENU];
extern MenuEntry menuFilterRxLo[MAX_MENU];
extern MenuEntry menuFilterRxHi[MAX_MENU];
extern MenuEntry menuAGC[MAX_MENU];
extern MenuEntry menuRecallMemory[MAX_MENU];
extern MenuEntry menuStoreMemory[MAX_MENU];
extern MenuEntry menuSettings[MAX_MENU];

Entry entry[CMD_LAST][MAX_ENTRY] = {
	/* "NONE" */				{{"<-",0}},
	/* "AGC_DEC" */				{{"fast",3000},{"medium",10000},{"slow",30000}},
	/* "ANT" */					{{"1",0},{"2",1}},
	/* "DISP_MODE" */			{{"Water",0},{"FFT",1},{"Dual",2},{"Dual2",3}},
	/* "FFT_COMPLEX" */			{},
	/* "FFT_SAMPLE_RATE" */		{},
	/* "FFT_SIZE" */			{{"256",256},{"512",512},{"1024",1024},{"2048",2048},{"4096",4096}},
	/* "FFT_TIME" */			{},
	/* "RX_FILTER_GAIN" */		{},
	/* "TX_FILTER_GAIN" */		{},
	/* "FILTER_RX_CUT" */		{},
	/* "FILTER_RX_HI" */		{{"1500",1500},{"1800",1800},{"2100",2100},{"2400",2400},{"2700",2700},{"3000",3000},{"3300",3300},{"3600",3600},{"3900",3900}},
	/* "FILTER_RX_LO" */		{{"10",10},{"50",50},{"100",100},{"200",200},{"300",300},{"500",500},{"700",700},{"1000",1000}},
	/* "FILTER_TX_CUT" */		{},
	/* "FILTER_TX_HI" */		{},
	/* "FILTER_TX_LO" */		{},
	/* "GAIN" */				{{"ANALOG",101},{"",0}},
	/* "MODE" */				{{"LSB",0},{"USB",1},{"CW",2},{"AM",3},{"FM",4}},
	/* "PRESEL" */				{},
	/* "POWER" */				{},
	/* "PREAMP" */				{{"-40 dB",-40},{"-30 dB",-30},{"-20 dB",-20},{"-10 dB",-10},{"-0 dB",0},{"10 dB",10},},
	/* "RAW_SRC" */				{{"wide",1},{"near",2}},
	/* "RSSI" */				{},
	/* "RX_FREQ" */				{},
	/* "SAMPLE_RATE */			{},
	/* "SMETER_MODE */			{{"rssi",0},{"level",1},{"power",2},{"swr",3}},
	/* "STEP */					{{"1 Hz",1},{"10 Hz",10},{"50 Hz",50},{"100 Hz",100},{"500 Hz",500},{"1 kHz",1000},{"5 kHz",5000},{"9 kHz",9000},{"10 kHz",10000},{"12.5 kHz",12500},{"20 kHz",20000},{"25 kHz",25000}},
	/* "SWR */					{},
	/* "TX */					{{"off",0},{"on",1}},
	/* "TX_RX */				{{"",0},{"",1}},
	/* "TX_FREQ */				{},
	/* "TX_POWER */				{{"ANALOG",256},{"",0}},
	/* "VOLUME */				{{"ANALOG",256},{"",0}},
	/* "MIC */					{{"ANALOG",256},{"",0}},
	/* "WATERFALL_MAX */		{{"ANALOG",WATERFALL_MAX},{"",-120}},
	/* "WATERFALL_MIN */		{{"ANALOG",WATERFALL_MIN},{"",-50}},
	/* "DIV1*/					{},
	/* "DIV2*/					{},
	/* "TWO_TONE_TEST */		{{"Audio",0},{"T2 -40 dB",1},{"T2 -30 dB",2},{"T2 -20 dB",3},{"T2 -10 dB",4},{"T2 0 dB",5},{"T1 0 dB",6}},
	/* "TX_DELAY */				{{"0ms",0},{"50ms",1},{"100ms",2},{"150ms",3},{"200ms",4},{"250ms",5},{"300ms",6},{"400ms",8},{"500ms",10},{"700ms",12},{"900ms",15}},
	/* "FULL_DUPLEX */			{{"",0},{"",1}},
	/* "NB_LEVEL */				{{"ANALOG",256},{"",0}},
	/* "INTERNAL */				{{"int",0},{"ext",1},{"off",2},{"HPSDR",3}},
	/* "NOTCH */				{{"off",0},{"1",1},{"2",2}},
	/* "SQUELCH */				{{"ANALOG",256},{"",0}},
	/* "DISP_COLOR */			{{"sw",0},{"color1",1},{"color2",2}},
	/* "SELECT0 */				{},
	/* "SELECT1 */				{
		{"AGC",CMD_AGC_DEC},
		{"Antenna",CMD_ANT},
		{"Band",CMD_BAND},
		{"Color",CMD_DISP_COLOR},
		{"Display",CMD_DISP_MODE},
		{"FFT",CMD_FFT_SIZE},
		{"Filter hi",CMD_FILTER_RX_HI},
		{"Filter lo",CMD_FILTER_RX_LO},
		{"Gain",CMD_GAIN},
		{"Intern",CMD_INTERNAL},
		{"Memory",CMD_RECALL_MEMORY},
		{"MicGain",CMD_MIC},
		{"Mode",CMD_MODE},
		{"NoiceBl",CMD_NB_LEVEL},
		{"Notch",CMD_NOTCH},
		{"Preamp",CMD_PREAMP},
		{"Range",CMD_RAW_SRC},
		{"S-Meter",CMD_SMETER_MODE},
		{"Squelch",CMD_SQUELCH},
		{"Step",CMD_STEP},
		{"TX==RX",CMD_TX_RX},
		{"TXDelay",CMD_TX_DELAY},
		{"TXPower",CMD_TX_POWER},
		{"TXSrc",CMD_TWO_TONE_TEST},
		{"WaterMax",CMD_WATERFALL_MAX},
		{"WaterMin",CMD_WATERFALL_MIN},
	},
	/* "INIT_END */				{},
	/* "EXIT */					{{"exit",0}},
	/* "MENU */					{},
	/* "NUMBER */				{{"0",0},{"1",1},{"2",2},{"3",3},{"4",4},{"5",5},{"6",6},{"7",7},{"8",8},{"9",9}},
	/* "STORE_MEMORY */ 		{{"0",0},{"1",1},{"2",2},{"3",3},{"4",4},{"5",5},{"6",6},{"7",7},{"8",8},{"9",9},{"10",10},{"11",11}},
	/* "RECONNECT */			{},
	/* "FREQ_STEP_DOWN */		{{"down",0}},
	/* "FREQ_STEP_UP */			{{"up",0}},
	/* "RECALL_MEMORY */		{{"0",0},{"1",1},{"2",2},{"3",3},{"4",4},{"5",5},{"6",6},{"7",7},{"8",8},{"9",9},{"10",10},{"11",11}},
	/* "BAND */					{{"no band",0},{"160 m",1},{"80 m",2},{"40 m",3},{"30 m",4},{"20 m",5},{"17 m",6},{"15 m",7},{"12 m",8},{"10 m",9},{"6m",10}},
	/* "INPUT_FREQ */			{{"Hz",0},{"kHz",1},{"Mhz",2}},
	/* "ADC_OV */				{},
	/* "IN_LEVEL */				{},
	/* "LAYOUT CHANGED */		{},
	/* "ENCODER0 */				{},
	/* "ENCODER1 */				{},
	/* "ENCODER2 */				{},
	/* "ENCODER3 */				{},
	/* "ENCODER4 */				{},
	/* "ENCODER5 */				{},
	/* "ENCODER6 */				{},
	/* "ENCODER7 */				{},
	/* "ENOCDER0_BUTTON */		{},
	/* "ENOCDER1_BUTTON */		{},
	/* "ENOCDER2_BUTTON */		{},
	/* "ENOCDER3_BUTTON */		{},
	/* "ENOCDER4_BUTTON */		{},
	/* "ENOCDER5_BUTTON */		{},
	/* "ENOCDER6_BUTTON */		{},
	/* "ENOCDER7_BUTTON */		{},
	/* "LAST */				
};


MenuEntry menuAGC[MAX_MENU] = {
	{entry[CMD_NONE][0],      CMD_NONE,    &menuMain},
	{entry[CMD_AGC_DEC][0],   CMD_AGC_DEC, &menuMain},
	{entry[CMD_AGC_DEC][1],   CMD_AGC_DEC, &menuMain},
	{entry[CMD_AGC_DEC][2],   CMD_AGC_DEC, &menuMain},
};

MenuEntry menuFilterRxLo[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_FILTER_RX_LO][0], CMD_FILTER_RX_LO, &menuMain},
	{entry[CMD_FILTER_RX_LO][1], CMD_FILTER_RX_LO, &menuMain},
	{entry[CMD_FILTER_RX_LO][2], CMD_FILTER_RX_LO, &menuMain},
	{entry[CMD_FILTER_RX_LO][3], CMD_FILTER_RX_LO, &menuMain},
	{entry[CMD_FILTER_RX_LO][4], CMD_FILTER_RX_LO, &menuMain},
	{entry[CMD_FILTER_RX_LO][5], CMD_FILTER_RX_LO, &menuMain},
	{entry[CMD_FILTER_RX_LO][6], CMD_FILTER_RX_LO, &menuMain},
};

MenuEntry menuFilterRxHi[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_FILTER_RX_HI][0], CMD_FILTER_RX_HI, &menuMain},
	{entry[CMD_FILTER_RX_HI][1], CMD_FILTER_RX_HI, &menuMain},
	{entry[CMD_FILTER_RX_HI][2], CMD_FILTER_RX_HI, &menuMain},
	{entry[CMD_FILTER_RX_HI][3], CMD_FILTER_RX_HI, &menuMain},
	{entry[CMD_FILTER_RX_HI][4], CMD_FILTER_RX_HI, &menuMain},
	{entry[CMD_FILTER_RX_HI][5], CMD_FILTER_RX_HI, &menuMain},
	{entry[CMD_FILTER_RX_HI][6], CMD_FILTER_RX_HI, &menuMain},
	{entry[CMD_FILTER_RX_HI][7], CMD_FILTER_RX_HI, &menuMain},
	{entry[CMD_FILTER_RX_HI][8], CMD_FILTER_RX_HI, &menuMain},
};

MenuEntry menuStep[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_STEP][0], CMD_STEP, &menuMain},
	{entry[CMD_STEP][1], CMD_STEP, &menuMain},
	{entry[CMD_STEP][2], CMD_STEP, &menuMain},
	{entry[CMD_STEP][3], CMD_STEP, &menuMain},
	{entry[CMD_STEP][4], CMD_STEP, &menuMain},
	{entry[CMD_STEP][5], CMD_STEP, &menuMain},
	{entry[CMD_STEP][6], CMD_STEP, &menuMain},
	{entry[CMD_STEP][7], CMD_STEP, &menuMain},
	{entry[CMD_STEP][8], CMD_STEP, &menuMain},
	{entry[CMD_STEP][9], CMD_STEP, &menuMain},
	{entry[CMD_STEP][10], CMD_STEP, &menuMain},
};

MenuEntry menuAtt[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_PREAMP][0], CMD_PREAMP, &menuMain},
	{entry[CMD_PREAMP][1], CMD_PREAMP, &menuMain},
	{entry[CMD_PREAMP][2], CMD_PREAMP, &menuMain},
	{entry[CMD_PREAMP][3], CMD_PREAMP, &menuMain},
	{entry[CMD_PREAMP][4], CMD_PREAMP, &menuMain},
	{entry[CMD_PREAMP][5], CMD_PREAMP, &menuMain},
};

MenuEntry menuDisplay[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_DISP_MODE][0], CMD_DISP_MODE, &menuMain},
	{entry[CMD_DISP_MODE][1], CMD_DISP_MODE, &menuMain},
	{entry[CMD_RAW_SRC][0],   CMD_RAW_SRC, &menuMain},
	{entry[CMD_RAW_SRC][1],   CMD_RAW_SRC, &menuMain},
};

MenuEntry menuMode[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_MODE][0], CMD_MODE, &menuMain},
	{entry[CMD_MODE][1], CMD_MODE, &menuMain},
	{entry[CMD_MODE][2], CMD_MODE, &menuMain},
	{entry[CMD_MODE][3], CMD_MODE, &menuMain},
	{entry[CMD_MODE][4], CMD_MODE, &menuMain},
};

MenuEntry menuFreq[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_NUMBER][0],  CMD_NUMBER, &menuFreq},
	{entry[CMD_NUMBER][1],  CMD_NUMBER, &menuFreq},
	{entry[CMD_NUMBER][2],  CMD_NUMBER, &menuFreq},
	{entry[CMD_NUMBER][3],  CMD_NUMBER, &menuFreq},
	{entry[CMD_NUMBER][4],  CMD_NUMBER, &menuFreq},
	{entry[CMD_NUMBER][5],  CMD_NUMBER, &menuFreq},
	{entry[CMD_NUMBER][6],  CMD_NUMBER, &menuFreq},
	{entry[CMD_NUMBER][7],  CMD_NUMBER, &menuFreq},
	{entry[CMD_NUMBER][8],  CMD_NUMBER, &menuFreq},
	{entry[CMD_NUMBER][9],  CMD_NUMBER, &menuFreq},
	{entry[CMD_INPUT_FREQ][1], CMD_INPUT_FREQ, &menuMain},
};

MenuEntry menuRecallMemory[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_RECALL_MEMORY][1],  CMD_RECALL_MEMORY, &menuMain},
	{entry[CMD_RECALL_MEMORY][2],  CMD_RECALL_MEMORY, &menuMain},
	{entry[CMD_RECALL_MEMORY][3],  CMD_RECALL_MEMORY, &menuMain},
	{entry[CMD_RECALL_MEMORY][4],  CMD_RECALL_MEMORY, &menuMain},
	{entry[CMD_RECALL_MEMORY][5],  CMD_RECALL_MEMORY, &menuMain},
	{entry[CMD_RECALL_MEMORY][6],  CMD_RECALL_MEMORY, &menuMain},
	{entry[CMD_RECALL_MEMORY][7],  CMD_RECALL_MEMORY, &menuMain},
	{entry[CMD_RECALL_MEMORY][8],  CMD_RECALL_MEMORY, &menuMain},
	{entry[CMD_RECALL_MEMORY][9],  CMD_RECALL_MEMORY, &menuMain},
	{entry[CMD_RECALL_MEMORY][10],  CMD_RECALL_MEMORY, &menuMain},
	{entry[CMD_RECALL_MEMORY][11],  CMD_RECALL_MEMORY, &menuMain},
};

MenuEntry menuStoreMemory[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_STORE_MEMORY][1],  CMD_STORE_MEMORY, &menuMain},
	{entry[CMD_STORE_MEMORY][2],  CMD_STORE_MEMORY, &menuMain},
	{entry[CMD_STORE_MEMORY][3],  CMD_STORE_MEMORY, &menuMain},
	{entry[CMD_STORE_MEMORY][4],  CMD_STORE_MEMORY, &menuMain},
	{entry[CMD_STORE_MEMORY][5],  CMD_STORE_MEMORY, &menuMain},
	{entry[CMD_STORE_MEMORY][6],  CMD_STORE_MEMORY, &menuMain},
	{entry[CMD_STORE_MEMORY][7],  CMD_STORE_MEMORY, &menuMain},
	{entry[CMD_STORE_MEMORY][8],  CMD_STORE_MEMORY, &menuMain},
	{entry[CMD_STORE_MEMORY][9],  CMD_STORE_MEMORY, &menuMain},
	{entry[CMD_STORE_MEMORY][10],  CMD_STORE_MEMORY, &menuMain},
	{entry[CMD_STORE_MEMORY][11],  CMD_STORE_MEMORY, &menuMain},
};

MenuEntry menuTxDelay[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_TX_DELAY][0], CMD_TX_DELAY, &menuMain},
	{entry[CMD_TX_DELAY][1], CMD_TX_DELAY, &menuMain},
	{entry[CMD_TX_DELAY][2], CMD_TX_DELAY, &menuMain},
	{entry[CMD_TX_DELAY][3], CMD_TX_DELAY, &menuMain},
	{entry[CMD_TX_DELAY][4], CMD_TX_DELAY, &menuMain},
	{entry[CMD_TX_DELAY][5], CMD_TX_DELAY, &menuMain},
	{entry[CMD_TX_DELAY][6], CMD_TX_DELAY, &menuMain},
	{entry[CMD_TX_DELAY][7], CMD_TX_DELAY, &menuMain},
	{entry[CMD_TX_DELAY][8], CMD_TX_DELAY, &menuMain},
	{entry[CMD_TX_DELAY][9], CMD_TX_DELAY, &menuMain},
	{entry[CMD_TX_DELAY][10], CMD_TX_DELAY, &menuMain},
};

MenuEntry menuSettings[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{ {"TxDelay", 0}, 0, &menuTxDelay},
};

MenuEntry menuAnt[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_ANT][0],  CMD_ANT, &menuMain},
	{entry[CMD_ANT][1],  CMD_ANT, &menuMain},
};

MenuEntry menuTxSrc[MAX_MENU] = {
	{entry[CMD_TWO_TONE_TEST][0],     CMD_TWO_TONE_TEST, &menuMain},
	{entry[CMD_TWO_TONE_TEST][1],     CMD_TWO_TONE_TEST, &menuMain},
	{entry[CMD_TWO_TONE_TEST][2],     CMD_TWO_TONE_TEST, &menuMain},
	{entry[CMD_TWO_TONE_TEST][3],     CMD_TWO_TONE_TEST, &menuMain},
	{entry[CMD_TWO_TONE_TEST][4],     CMD_TWO_TONE_TEST, &menuMain},
	{entry[CMD_TWO_TONE_TEST][5],     CMD_TWO_TONE_TEST, &menuMain},
};

MenuEntry menuBand[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_BAND][1], CMD_BAND, &menuMain},
	{entry[CMD_BAND][2], CMD_BAND, &menuMain},
	{entry[CMD_BAND][3], CMD_BAND, &menuMain},
	{entry[CMD_BAND][4], CMD_BAND, &menuMain},
	{entry[CMD_BAND][5], CMD_BAND, &menuMain},
	{entry[CMD_BAND][6], CMD_BAND, &menuMain},
	{entry[CMD_BAND][7], CMD_BAND, &menuMain},
	{entry[CMD_BAND][8], CMD_BAND, &menuMain},
	{entry[CMD_BAND][9], CMD_BAND, &menuMain},
	{entry[CMD_BAND][10], CMD_BAND, &menuMain},
};

MenuEntry menuNotch[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{entry[CMD_NOTCH][0],  CMD_NOTCH, &menuMain},
	{entry[CMD_NOTCH][1],  CMD_NOTCH, &menuMain},
	{entry[CMD_NOTCH][2],  CMD_NOTCH, &menuMain},
};

MenuEntry menuMain1[MAX_MENU] = {
	{entry[CMD_NONE][0],     CMD_NONE, &menuMain},
	{ {"MStore",   0}, 0, &menuStoreMemory},
	{ {"Settings", 0}, 0, &menuSettings},
	{ {"TX-Src", 0}, 0, &menuTxSrc},
	{ {"Notch", 0}, 0, &menuNotch},
};

MenuEntry menuMain[MAX_MENU] = {
	{ {"Freq",    0}, 0, &menuFreq},
	{ {"Step",    0}, 0, &menuStep},
	{ {"Band",    0}, 0, &menuBand},
	{ {"Mode",    0}, 0, &menuMode},
	{ {"Display", 0}, 0, &menuDisplay},
	{ {"Ant",     0}, 0, &menuAnt},
	{ {"Att",     0}, 0, &menuAtt},
	{ {"Fi Lo",   0}, 0, &menuFilterRxLo},
	{ {"Fi Hi",   0}, 0, &menuFilterRxHi},
	{ {"AGC",     0}, 0, &menuAGC},
	{ {"MRecall", 0}, 0, &menuRecallMemory},
	{ {"more",    0}, 0, &menuMain1},
}; 


Display_touch::Display_touch(QWidget* /*parent*/) : Display_base(), ui(new Ui::Display_touch) {

	initReady = false;
	settings =  new QSettings("sdr","rasdr");
	fftWidthOffset = getSettings(settings,"Common/fftWidthOffset", 13.0)/20.0;
	fftNearOffset = getSettings(settings,"Common/fftNearOffset",5.0)/20.0;
	timer = new QTimer();

	fftSize=FFT_SIZE;
	fftSampRate = RX_CLOCK; 
	rxFreq = 7100000;
	txFreq = 7100000;
	update = true;
	inputMode = false;
	inputVal = 0;
	txrx = true;
	div1 = 8;
	div2 = 40;
	ptt = 0;
	smtr = NULL;
	fullScreen = 0;
	volume = 0;
	encSens = 5;
	encDelta = 0;

	for(int i=0;i<arraysize(mem);i++) {
		mem[i].name = QString("mem %1").arg(i+1);
		mem[i].mode = MODE_LSB;
		mem[i].rxFreq = 7000000;
		mem[i].txFreq = 7000000; 
		mem[i].filterLo = 100;
		mem[i].filterHi = 2700;
		mem[i].preamp = 0;
		mem[i].ant = 0;
	}
	
	for(int i=0;i<arraysize(memBand);i++) {
		memBand[i].name = QString("memBand %1").arg(i+1);
		memBand[i].mode = MODE_LSB;
		if (i>1)
			memBand[i].mode = MODE_USB;
		memBand[i].rxFreq = bandMin[i];
		memBand[i].txFreq = bandMin[i]; 
		memBand[i].filterLo = 100;
		memBand[i].filterHi = 2700;
		memBand[i].preamp = 0;
		memBand[i].ant = 0;
	}

	for (int i=0;i<arraysize(button);i++) {
		button[i].name = "unused";
		button[i].xPos = 0;
		button[i].yPos = 0;
		button[i].xSize = 0;
		button[i].ySize = 0;
		button[i].pos = 0;
		button[i].cmd = 0;
	}
	for (int i=0;i<arraysize(analog);i++) {
		analog[i].name = "unused";
		analog[i].xPos = 0;
		analog[i].yPos = 0;
		analog[i].xSize = 0;
		analog[i].ySize = 0;
		analog[i].min = 0;
		analog[i].max = 0;
		analog[i].pos = 0;
		analog[i].cmd = 0;
	}
	for (int i=0;i<arraysize(label);i++) {
		label[i].name = "unused";
		label[i].xPos = 0;
		label[i].yPos = 0;
		label[i].xSize = 0;
		label[i].ySize = 0;
		label[i].cmd = 0;
	}
	memset(cmdStore, 0, sizeof(cmdStore));
	readSettings();

	calcCicCorr();

    ui->setupUi(this);
	show();
	if (touchscreen)
		this->setWindowState(Qt::WindowFullScreen);
	//resize(DISP_X_SIZE*GRID_SIZE,DISP_Y_SIZE*GRID_SIZE);
	//ui->graphicsView->resize(DISP_X_SIZE*GRID_SIZE, DISP_Y_SIZE*GRID_SIZE);
	ui->graphicsView->setMouseTracking(true);

	QLinearGradient linearGrad(QPointF(0, -0), QPointF(DSIZE_X, DSIZE_X));
	linearGrad.setColorAt(0, QColor(getSettings(settings,"display/colorBackground1","#1f1f1f")));
	linearGrad.setColorAt(1, QColor(getSettings(settings,"display/colorBackground2","#4b4b4b")));

	scene = new QGraphicsScene();
	// ui->graphicsView->setRenderHint(QPainter::Antialiasing);
	scene->setBackgroundBrush(linearGrad);
	scene->setItemIndexMethod(QGraphicsScene::NoIndex);

	fftGraph = new FFTGraph(0,0);
	scene->addItem(fftGraph);
	filterGraph = new FilterGraph(0,0);
	scene->addItem(filterGraph);

	smtr = new SMeter();
	scene->addItem(smtr);

	rxfreq = new Numeric("RX", 0, 0, rxFreq,8,0,RX_CLOCK/2) ;
	scene->addItem(rxfreq);
	txfreq = new Numeric("TX", 0, 0, txFreq,8,0,RX_CLOCK/2) ;
	scene->addItem(txfreq);
	input = new Numeric("",0,0,0,5,0,99999) ;
	scene->addItem(input);
	clock = new Clock(0,0) ;
	scene->addItem(clock);

	ui->graphicsView->setScene(scene);

	fftGraph->setMin(-120);
	fftGraph->setMax(-50);

	setLayout(layOut);

	for (int i=0;i<fftSize;i++)
		window.push_back(0.5  - 0.5  * cos (2 * M_PI / (fftSize) * i));  // Hanning window

	in  = (fftwf_complex*) fftwf_malloc(sizeof(fftwf_complex) * fftSize);
	out = (fftwf_complex*) fftwf_malloc(sizeof(fftwf_complex) * fftSize);
	plan = fftwf_plan_dft_1d(fftSize, in, out, FFTW_FORWARD, FFTW_ESTIMATE);

	connect(timer, SIGNAL(timeout()), this, SLOT(updateOn()));
	connect(smtr, SIGNAL(pressed(int,int)), this, SLOT(smtrPressed(int,int)));
	connect(rxfreq, SIGNAL(changed(int)), this, SLOT(setFreq(int)));
	connect(txfreq, SIGNAL(changed(int)), this, SLOT(setTXFreq(int)));
	connect(filterGraph, SIGNAL(freqChanged(int)), this, SLOT(setFreq(int)));

	initReady = true;
	resize(settings->value("Size",QSize(DSIZE_X,DSIZE_Y)).toSize()); 
	resizeDisp(settings->value("Size",QSize(DSIZE_X,DSIZE_Y)).toSize()); 
}


Display_touch::~Display_touch() {
	writeSettings();

	fftwf_destroy_plan(plan);
	fftwf_free(in); 
	fftwf_free(out);

    delete ui;
	delete settings;
}

void Display_touch::start() {
}

void Display_touch::calcCicCorr() {
	// calculate cic magnitude correction
	double N=5.0;
	double M=1.0;
	double R=2.0;
	double f=1e-6;
	double corr0 = log10(pow(fabs(sin(M_PI*M*f)/sin(M_PI*f/R)),N));
	cicCorr[fftSize/2]=1; //corr0;
	for(int i=1; i < fftSize/2; i++) {
		f = (double)i/fftSize;
		double corr = log10(pow(fabs(sin(M_PI*M*f)/sin(M_PI*f/R)),N)) - corr0;
		cicCorr[fftSize/2-i] = corr; 
		cicCorr[fftSize/2+i] = corr; 
	}
}

void Display_touch::resizeEvent(QResizeEvent* event) {
	resizeDisp(event->size());
}

void Display_touch::resizeDisp(QSize size) {
	int xs = size.width();
	int ys = size.height();

	if (!initReady)
		return;
#if 0
#ifndef ANDROID
	if (layOut == 0 && xs>=1072)
		setLayout(2);
	if (layOut == 1 && xs< 1072)
		setLayout(1);
#endif
#endif

	if (!smtr)
		return;
	scene->setSceneRect(0,0,xs-4,ys-4);

	// Buttons

	switch (layOut) {
		case 0:
		case 1:
			for (int i=0;i<arraysize(button);i++) {
				if (button[i].cmd != CMD_NONE) {
					button[i].button->setPos(button[i].xPos*xs/DSIZE_X, button[i].yPos*ys/DSIZE_Y);
					button[i].button->setScale(1.0*xs/DSIZE_X);
				}
				if (analog[i].cmd != CMD_NONE) {
					analog[i].analog->setPos(analog[i].xPos*xs/DSIZE_X, analog[i].yPos*ys/DSIZE_Y);
					analog[i].analog->setScale(1.0*xs/DSIZE_X);
				}
				if (label[i].cmd != CMD_NONE) {
					label[i].label->setPos(label[i].xPos*xs/DSIZE_X, label[i].yPos*ys/DSIZE_Y);
					label[i].label->setScale(1.0*xs/DSIZE_X);
				}
			}
			for (int i=0;i<ITEM_MAX;i++) {
				if (items[i].it) {
					items[i].it->setPos (items[i]. xPos*xs/DSIZE_X, items[i]. yPos*ys/DSIZE_Y);
					items[i].it->setSize(items[i].xSize*xs/DSIZE_X, items[i].ySize*ys/DSIZE_Y);
				}
			}
			break;

		case 2:
			for (int i=0;i<arraysize(button);i++) {
				if (button[i].cmd != CMD_NONE) 
					button[i].button->setPos(button[i].xPos, ys-DSIZE_Y + button[i].yPos);
				if (analog[i].cmd != CMD_NONE) 
					analog[i].analog->setPos(analog[i].xPos, ys-DSIZE_Y + analog[i].yPos);
				if (label[i].cmd != CMD_NONE) 
					label[i].label->setPos(label[i].xPos, ys-DSIZE_Y + label[i].yPos);
			}
			for (int i=0;i<ITEM_MAX;i++) {
				if (items[i].it) {
					if (items[i].yPos >= 30*GRID_SIZE) {
						items[i].it->setPos (items[i].xPos, ys-DSIZE_Y + items[i].yPos);
						items[i].it->setSize(items[i].xSize, items[i].ySize);
					} else {
						items[i].it->setPos (items[i]. xPos*xs/DSIZE_X, items[i]. yPos*ys/DSIZE_Y);
						items[i].it->setSize(items[i].xSize*xs/DSIZE_X, items[i].ySize*ys/DSIZE_Y);
					}
				}
			}
			break;
	}


}

void Display_touch::setLayout(int l) {
	int aIdx = 0;
	int bIdx = 0;
	int lIdx = 0;
	int xp,yp,xs,ys;

	layOut = l;

	for (int i=0;i<arraysize(button);i++) {
		if (analog[i].cmd != CMD_NONE) {
			scene->removeItem(analog[i].analog);
			delete analog[i].analog;
			analog[i].cmd = CMD_NONE;
		}
		if (button[i].cmd != CMD_NONE) {
			scene->removeItem(button[i].button);
			delete button[i].button;
			button[i].cmd = CMD_NONE;
		}
		if (label[i].cmd != CMD_NONE) {
			scene->removeItem(label[i].label);
			delete label[i].label;
			label[i].cmd = CMD_NONE;
		}
	}

	switch (layOut) {
		case 0:
		default:
			items[ITEM_SMTR]        = {smtr,        16*GRID_SIZE,  7*GRID_SIZE, 74*GRID_SIZE,  1*GRID_SIZE};
			items[ITEM_RXFREQ]      = {rxfreq,      36*GRID_SIZE,  7*GRID_SIZE,  1*GRID_SIZE,  1*GRID_SIZE};
			items[ITEM_TXFREQ]      = {txfreq,      36*GRID_SIZE,  7*GRID_SIZE, 37*GRID_SIZE,  1*GRID_SIZE};
			items[ITEM_INPUT]       = {input,       12*GRID_SIZE,  3*GRID_SIZE,  1*GRID_SIZE,  9*GRID_SIZE};
			items[ITEM_FILTERGRAPH] = {filterGraph, 64*GRID_SIZE, 29*GRID_SIZE,  1*GRID_SIZE, 13*GRID_SIZE};
			items[ITEM_FFTGRAPH]    = {fftGraph,    64*GRID_SIZE, 29*GRID_SIZE,  1*GRID_SIZE, 13*GRID_SIZE};
			items[ITEM_CLOCK]       = {clock,       17*GRID_SIZE,  3*GRID_SIZE, 14*GRID_SIZE,  9*GRID_SIZE};

			xp = 32*GRID_SIZE; yp = 9*GRID_SIZE; xs = 7*GRID_SIZE; ys = 3*GRID_SIZE; 
			NEW_BUTTON("Color", 0, CMD_DISP_COLOR); RIGHT;
			NEW_BUTTON("Zoom", 2, CMD_FFT_SIZE); RIGHT; 
			NEW_BUTTON("Notch", 0, CMD_NOTCH); RIGHT; 
			NEW_BUTTON("FDX", 1, CMD_FULL_DUPLEX); RIGHT;
			NEW_BUTTON("TX=RX", 1, CMD_TX_RX);

			xp = 66*GRID_SIZE; yp = 13*GRID_SIZE; xs = 5*GRID_SIZE; ys = 14*GRID_SIZE; 
			NEW_ANALOG("Max", -120,WATERFALL_MAX,-50,CMD_WATERFALL_MAX); DOWN;
			NEW_ANALOG("Min", WATERFALL_MIN,-50,-120,CMD_WATERFALL_MIN); 
			xp = 72*GRID_SIZE; yp =  9*GRID_SIZE; xs = 12*GRID_SIZE; ys =  6*GRID_SIZE; 

			NEW_BUTTON("Filter hi", 4, CMD_FILTER_RX_HI); DOWN;
			NEW_BUTTON("Filter lo", 3, CMD_FILTER_RX_LO); DOWN;
			NEW_BUTTON("Step", 2, CMD_STEP); DOWN;
			NEW_BUTTON("Range", 0, CMD_RAW_SRC); DOWN; 
			xs = 6*GRID_SIZE;
			NEW_BUTTON("", 0, CMD_FREQ_STEP_DOWN); xp+=xs;
			NEW_BUTTON("", 0, CMD_FREQ_STEP_UP); xp-=xs; DOWN;
			xs = 12*GRID_SIZE; ys =  7*GRID_SIZE; 
			NEW_BUTTON("TX-Src", 0, CMD_TWO_TONE_TEST);

			xp = 85*GRID_SIZE; yp =  9*GRID_SIZE; xs = 12*GRID_SIZE; ys =  6*GRID_SIZE; 
			NEW_BUTTON("Mode", 0, CMD_MODE); DOWN;
			NEW_BUTTON("Antenna", 0, CMD_ANT); DOWN;
			NEW_BUTTON("Preamp", 0, CMD_PREAMP); DOWN;
			NEW_BUTTON("AGC",  1, CMD_AGC_DEC); DOWN;
			NEW_BUTTON("Display", 0, CMD_DISP_MODE); DOWN;

			xs = 12*GRID_SIZE; ys =  7*GRID_SIZE; 
			NEW_BUTTON("TX", 0, CMD_TX);

			xp = 89*GRID_SIZE; yp = 1*GRID_SIZE; xs = 8*GRID_SIZE; ys = 7 *GRID_SIZE; 
			NEW_BUTTON("", 0, CMD_SMETER_MODE);

			xp =  1*GRID_SIZE; yp = 43*GRID_SIZE; xs =  7*GRID_SIZE; ys = 4*GRID_SIZE; 
			NEW_BUTTON("Intern", 0, CMD_INTERNAL); yp+=ys;;
			NEW_BUTTON("OFF", 0, CMD_EXIT); RIGHT; 

			yp = 43*GRID_SIZE; xs = 7*GRID_SIZE; ys=8*GRID_SIZE;
			NEW_ANALOG("Volume", 0,255,30,CMD_VOLUME); RIGHT;
			NEW_ANALOG("Mic", 0,255,0,CMD_MIC); RIGHT;
			NEW_ANALOG("TX",0,255,30,CMD_TX_POWER); RIGHT;
			NEW_ANALOG("Gain",0,100,0,CMD_GAIN);  RIGHT;
			NEW_ANALOG("NB",0,255,255,CMD_NB_LEVEL);  RIGHT;
			NEW_ANALOG("Squelch",0,255,255,CMD_SQUELCH);  RIGHT;

			xs =12*GRID_SIZE, ys=2*GRID_SIZE;
			NEW_LABEL("Gain",CMD_GAIN); yp+=ys;
			NEW_LABEL("Vol",CMD_VOLUME); yp+=ys;
			NEW_LABEL("Mode",CMD_MODE); yp+=ys;
			NEW_LABEL("SWR",CMD_SWR);

			xp = 1*GRID_SIZE; yp = 52*GRID_SIZE; xs = 7*GRID_SIZE; ys =  5*GRID_SIZE; 
			menuStartIdx = bIdx;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;

			curMenu = &menuMain;
			for (int i=0;i<MAX_MENU;i++) {
				button[menuStartIdx + i].buttonText.append((*curMenu)[i].entry.name);
				button[menuStartIdx + i].buttonValue[0]=i;
			}
			break;

		case 1:
			items[ITEM_SMTR]        = {smtr,        16*GRID_SIZE,  7*GRID_SIZE, 74*GRID_SIZE,  1*GRID_SIZE};
			items[ITEM_RXFREQ]      = {rxfreq,      36*GRID_SIZE,  7*GRID_SIZE,  1*GRID_SIZE,  1*GRID_SIZE};
			items[ITEM_TXFREQ]      = {txfreq,      36*GRID_SIZE,  7*GRID_SIZE, 37*GRID_SIZE,  1*GRID_SIZE};
			items[ITEM_INPUT]       = {input,       12*GRID_SIZE,  3*GRID_SIZE,  1*GRID_SIZE,  9*GRID_SIZE};
			items[ITEM_FILTERGRAPH] = {filterGraph, 64*GRID_SIZE, 29*GRID_SIZE,  1*GRID_SIZE, 13*GRID_SIZE};
			items[ITEM_FFTGRAPH]    = {fftGraph,    64*GRID_SIZE, 29*GRID_SIZE,  1*GRID_SIZE, 13*GRID_SIZE};
			items[ITEM_CLOCK]       = {clock,       17*GRID_SIZE,  3*GRID_SIZE, 14*GRID_SIZE,  9*GRID_SIZE};

			xp = 32*GRID_SIZE; yp = 9*GRID_SIZE; xs = 7*GRID_SIZE; ys = 3*GRID_SIZE; 
			NEW_BUTTON("Color", 0, CMD_DISP_COLOR); RIGHT;
			NEW_BUTTON("Zoom", 2, CMD_FFT_SIZE); RIGHT; 
			NEW_BUTTON("Notch", 0, CMD_NOTCH); RIGHT; 
			NEW_BUTTON("FDX", 1, CMD_FULL_DUPLEX); RIGHT;
			NEW_BUTTON("TX=RX", 1, CMD_TX_RX);

			xp = 66*GRID_SIZE; yp = 13*GRID_SIZE; xs = 5*GRID_SIZE; ys = 14*GRID_SIZE; 
			NEW_ANALOG("Max", -120,WATERFALL_MAX,-50,CMD_WATERFALL_MAX); DOWN;
			NEW_ANALOG("Min", WATERFALL_MIN,-50,-120,CMD_WATERFALL_MIN); 

			xp = 72*GRID_SIZE; yp =  9*GRID_SIZE; xs = 25*GRID_SIZE; ys =  6*GRID_SIZE; 
			NEW_BUTTON("", 0, CMD_SELECT0); DOWN;
			select0ButtonIdx = bIdx-1;
			NEW_BUTTON("Select", 0, CMD_SELECT1); DOWN;
			select1ButtonIdx = bIdx-1;
			xs = 12*GRID_SIZE;

			NEW_BUTTON("Step", 2, CMD_STEP); DOWN;
			NEW_BUTTON("Range", 0, CMD_RAW_SRC); DOWN; 
			xs = 6*GRID_SIZE;
			NEW_BUTTON("", 0, CMD_FREQ_STEP_DOWN); xp+=xs;
			NEW_BUTTON("", 0, CMD_FREQ_STEP_UP); xp-=xs; DOWN;
			xs = 12*GRID_SIZE; ys =  7*GRID_SIZE; 
			NEW_BUTTON("TX-Src", 0, CMD_TWO_TONE_TEST);

			xp = 85*GRID_SIZE; yp =  9*GRID_SIZE+((6+1)*2)*GRID_SIZE; xs = 12*GRID_SIZE; ys =  6*GRID_SIZE; 
			NEW_BUTTON("Mode", 0, CMD_MODE); DOWN;
			NEW_BUTTON("AGC",  1, CMD_AGC_DEC); DOWN;
			NEW_BUTTON("Display", 0, CMD_DISP_MODE); DOWN;

			xs = 12*GRID_SIZE; ys =  7*GRID_SIZE; 
			NEW_BUTTON("TX", 0, CMD_TX);

			xp = 89*GRID_SIZE; yp = 1*GRID_SIZE; xs = 8*GRID_SIZE; ys = 7 *GRID_SIZE; 
			NEW_BUTTON("", 0, CMD_SMETER_MODE);

			xp =  1*GRID_SIZE; yp = 43*GRID_SIZE; xs =  7*GRID_SIZE; ys = 4*GRID_SIZE; 
			NEW_BUTTON("Intern", 0, CMD_INTERNAL); yp+=ys;;
			NEW_BUTTON("OFF", 0, CMD_EXIT); RIGHT; 

			yp = 43*GRID_SIZE; xs = 7*GRID_SIZE; ys=8*GRID_SIZE;
			NEW_ANALOG("Volume", 0,255,30,CMD_VOLUME); RIGHT;
			NEW_ANALOG("Mic", 0,255,0,CMD_MIC); RIGHT;
			NEW_ANALOG("TX",0,255,30,CMD_TX_POWER); RIGHT;
			NEW_ANALOG("Gain",0,100,0,CMD_GAIN);  RIGHT;
			NEW_ANALOG("NB",0,255,255,CMD_NB_LEVEL);  RIGHT;
			NEW_ANALOG("Squelch",0,255,255,CMD_SQUELCH);  RIGHT;


			xp = 1*GRID_SIZE; yp = 52*GRID_SIZE; xs = 7*GRID_SIZE; ys =  5*GRID_SIZE; 
			menuStartIdx = bIdx;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT;

			curMenu = &menuMain;
			for (int i=0;i<MAX_MENU;i++) {
				button[menuStartIdx + i].buttonText.append((*curMenu)[i].entry.name);
				button[menuStartIdx + i].buttonValue[0]=i;
			}
			break;

		case 2:
			items[ITEM_RXFREQ]      = {rxfreq,      30*GRID_SIZE,  5*GRID_SIZE,  1*GRID_SIZE, 39*GRID_SIZE};
			items[ITEM_TXFREQ]      = {txfreq,      30*GRID_SIZE,  5*GRID_SIZE, 32*GRID_SIZE, 39*GRID_SIZE};
			items[ITEM_INPUT]       = {input,       16*GRID_SIZE,  5*GRID_SIZE, 63*GRID_SIZE, 39*GRID_SIZE};
			items[ITEM_SMTR]        = {smtr,        16*GRID_SIZE,  6*GRID_SIZE, 80*GRID_SIZE, 38*GRID_SIZE};
			items[ITEM_FILTERGRAPH] = {filterGraph,100*GRID_SIZE, 60*GRID_SIZE,  0*GRID_SIZE,  0*GRID_SIZE};
			items[ITEM_FFTGRAPH]    = {fftGraph,   100*GRID_SIZE, 60*GRID_SIZE,  0*GRID_SIZE,  0*GRID_SIZE};

			xp =  1*GRID_SIZE; yp = 45*GRID_SIZE; xs =  8*GRID_SIZE; ys = 4*GRID_SIZE; 
			NEW_BUTTON("Int", 0, CMD_INTERNAL); DOWN2; 
			NEW_BUTTON("Color", 0, CMD_DISP_COLOR); DOWN2;
			NEW_BUTTON("OFF", 0, CMD_EXIT); RIGHT2; 

			UP2;UP2;	

			xs = 5*GRID_SIZE; ys =13*GRID_SIZE; 
			NEW_ANALOG("Vol", 0,255,30,CMD_VOLUME); RIGHT2;
			NEW_ANALOG("Mic", 0,255,0,CMD_MIC); RIGHT2;
			NEW_ANALOG("TX",0,255,30,CMD_TX_POWER); RIGHT2;
			NEW_ANALOG("Gain",0,100,0,CMD_GAIN);  RIGHT2;
			NEW_ANALOG("NB",0,255,255,CMD_NB_LEVEL);  RIGHT2;
			NEW_ANALOG("Squ",0,255,255,CMD_SQUELCH);  RIGHT2;
			NEW_ANALOG("Max", -120,WATERFALL_MAX,-50,CMD_WATERFALL_MAX); RIGHT2;
			NEW_ANALOG("Min", WATERFALL_MIN,-50,-120,CMD_WATERFALL_MIN); RIGHT2; 

			xs = 8*GRID_SIZE; ys =  4*GRID_SIZE; 
			NEW_BUTTON("Zoom", 2, CMD_FFT_SIZE); DOWN2; 
			NEW_BUTTON("Range", 0, CMD_RAW_SRC); DOWN2; 
			NEW_BUTTON("Display", 0, CMD_DISP_MODE); DOWN2;

			RIGHT2;UP2;UP2;UP2;
			NEW_BUTTON("TX=RX", 1, CMD_TX_RX); DOWN2;
			NEW_BUTTON("Filter hi", 4, CMD_FILTER_RX_HI); DOWN2;
			NEW_BUTTON("Filter lo", 3, CMD_FILTER_RX_LO); DOWN2;

			RIGHT2;UP2;UP2;UP2;
			NEW_BUTTON("Step", 2, CMD_STEP); DOWN2;
			NEW_BUTTON("Notch", 0, CMD_NOTCH); DOWN2; 
			NEW_BUTTON("", 0, CMD_FREQ_STEP_DOWN); DOWN2;

			RIGHT2;UP2;UP2;UP2;
			NEW_BUTTON("Mode", 0, CMD_MODE); DOWN2;
			NEW_BUTTON("Antenna", 0, CMD_ANT); DOWN2;
			NEW_BUTTON("", 0, CMD_FREQ_STEP_UP); DOWN2;

			RIGHT2;UP2;UP2;UP2;
			NEW_BUTTON("S-Meter", 0, CMD_SMETER_MODE); DOWN2;
			NEW_BUTTON("Preamp", 0, CMD_PREAMP); DOWN2;
			NEW_BUTTON("AGC",  1, CMD_AGC_DEC); DOWN2;

			RIGHT2;UP2;UP2;UP2;
			NEW_BUTTON("FDX", 1, CMD_FULL_DUPLEX); DOWN2;
			NEW_BUTTON("TX-Src", 0, CMD_TWO_TONE_TEST); DOWN2;
			NEW_BUTTON("TX", 0, CMD_TX); DOWN2;

#if 0
			RIGHT2;UP2;UP2;UP2;
			NEW_LABEL("Gain",CMD_GAIN); DOWN2; 
			NEW_LABEL("Vol",CMD_VOLUME); DOWN2; 
			NEW_LABEL("Mode",CMD_MODE); DOWN2; 

			RIGHT2;UP2;UP2;UP2;
			NEW_LABEL("SWR",CMD_SWR); DOWN2;
			DOWN2;
			DOWN2;
#endif

			menuStartIdx = bIdx;

			xp += GRID_SIZE*2 ; RIGHT2; UP2;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT2; 
			NEW_BUTTON("", 0, CMD_MENU); 

			LEFT2; UP2;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT2; 
			NEW_BUTTON("", 0, CMD_MENU); RIGHT2; 
			NEW_BUTTON("", 0, CMD_MENU); 

			LEFT2; LEFT2; UP2;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT2; 
			NEW_BUTTON("", 0, CMD_MENU); RIGHT2; 
			NEW_BUTTON("", 0, CMD_MENU); 
			
			LEFT2; LEFT2; UP2;
			NEW_BUTTON("", 0, CMD_MENU); RIGHT2; 
			NEW_BUTTON("", 0, CMD_MENU); RIGHT2; 
			NEW_BUTTON("", 0, CMD_MENU); 

			DOWN2; DOWN2; DOWN2;
			NEW_BUTTON("", 0, CMD_MENU); 

			curMenu = &menuMain;
			for (int i=0;i<MAX_MENU;i++) {
				button[menuStartIdx + i].buttonText.append((*curMenu)[i].entry.name);
				button[menuStartIdx + i].buttonValue[0]=i;
			}
			break;
	}

	// Buttons
	for (int i=0;i<arraysize(button);i++) {
		if (button[i].cmd == 0)
			continue;
		button[i].button = new TextButton(&button[i]);		
		scene->addItem(button[i].button);
		button[i].button->setPos(button[i].xPos, button[i].yPos);
		connect(button[i].button, SIGNAL(pressed(int,int)), this, SLOT(buttonPressed(int,int)));
	}

	// Analog
	for (int i=0;i<arraysize(analog);i++) {
		if (analog[i].cmd == 0)
			continue;
		analog[i].analog = new Analog(&analog[i]);		
		scene->addItem(analog[i].analog);
		analog[i].analog->setPos(analog[i].xPos, analog[i].yPos);
		connect(analog[i].analog, SIGNAL(changed(int,int)), this, SLOT(analogChanged(int,int)));
	}

	// Label 
	for (int i=0;i<arraysize(label);i++) {
		if (label[i].cmd == 0)
			continue;
		label[i].label = new Label(&label[i]);		
		scene->addItem(label[i].label);
		label[i].label->setPos(label[i].xPos, label[i].yPos);
	}

	emit command(SRC_DISP, CMD_LAYOUT_CHANGED, layOut); 
}

int Display_touch::getVal(int cmd) {
	return cmdStore[cmd];
}

void Display_touch::setVal(int cmd, int val) {
	cmdStore[cmd]=val;
	for (int i=0;i<arraysize(label);i++) {
		if (label[i].cmd == CMD_NONE)
			break;
		if (label[i].cmd == cmd) {
			label[i].label->setVal(val);
			// only one label
			break;
		}
	}
	for (int i=0;i<arraysize(button);i++) {
		if (button[i].cmd == CMD_NONE)
			break;
		if (button[i].cmd == cmd) {
			button[i].button->setVal(val);
		}
	}
	for (int i=0;i<arraysize(analog);i++) {
		if (analog[i].cmd == CMD_NONE)
			break;
		if (analog[i].cmd == cmd) {
			analog[i].analog->setVal(val);
			break;;
		}
	}
	return;
}

void Display_touch::setFreq(int f) {
	storeBand();
	filterGraph->setFreq(f);
	displaySet(SRC_DISP, CMD_RX_FREQ, f);
	if (txrx)
		displaySet(SRC_DISP, CMD_TX_FREQ, f);
}

void Display_touch::setTXFreq(int f) {
	displaySet(SRC_DISP, CMD_TX_FREQ, f);
	if (txrx)
		displaySet(SRC_DISP, CMD_RX_FREQ, f);
}

void Display_touch::displaySet(int src, int cmd, int val) {
	int freq;
	PDEBUG(MSG1, "%s -> Display: %s, Par: %i",SrcString[src], CmdString[cmd],val);
	if (src != SRC_CTL)
		sendCmd(cmd, val);
	setVal(cmd, val);
	switch (cmd) {
		case CMD_MENU:
			if ((*curMenu)[val].cmd != CMD_NONE)
				displaySet(SRC_DISP, (*curMenu)[val].cmd, (*curMenu)[val].entry.par);
			if ((*curMenu)[val].next) {
				lastMenu = curMenu;
				curMenu = (*curMenu)[val].next;
				for (int i=0;i<MAX_MENU;i++) {
					button[menuStartIdx + i].buttonText[0] = (*curMenu)[i].entry.name;
					button[menuStartIdx + i].button->doUpdate();
				}
			}
			if (val==0) {
				inputVal = 0;
				input->setVal(inputVal);
			}
			break;
		case CMD_RX_FREQ:
			freqChanged(val);
			break;
		case CMD_TX_RX:
			txrx = val;
			if (txrx)
				setTXFreq(rxFreq);
			break;
		case CMD_TX_FREQ:
			txFreq = val;
			txfreq->setVal(txFreq);
			break;
		case CMD_MODE:
			filterGraph->setFilter(rxFreq, getVal(CMD_FILTER_RX_LO), getVal(CMD_FILTER_RX_HI), getVal(CMD_MODE));
			break;
		case CMD_FFT_SAMPLE_RATE:
			fftSampRate = val;
			filterGraph->setSampleRate(fftSampRate);
			break;
		case CMD_FFT_SIZE:
			setFFTSize(val);
			break;
		case CMD_DISP_MODE:
			fftGraph->setDisplayMode(val);
			filterGraph->setDisplayMode(val);
			break;
		case CMD_FILTER_RX_HI:
		case CMD_FILTER_RX_LO:
			filterGraph->setFilter(rxFreq, getVal(CMD_FILTER_RX_LO), getVal(CMD_FILTER_RX_HI), getVal(CMD_MODE));
			break;
		case CMD_RECALL_MEMORY:
			setMemory(val==0 ? inputVal: val);
			inputVal = 0;
			break;
		case CMD_STORE_MEMORY:
			storeMemory(val==0 ? inputVal: val);
			inputVal = 0;
			break;
		case CMD_FREQ_STEP_UP:
			freq = rxFreq + step;
			freq -= (freq % step);
			setFreq(freq);
			break;
		case CMD_FREQ_STEP_DOWN:
			freq = rxFreq;
			if ((freq % step) == 0)
				freq-= step;
			freq -= (freq % step);
			setFreq(freq);
			break;
		case CMD_INPUT_FREQ:
			setFreq(inputVal*1000);
			inputVal = 0;
			input->setVal(inputVal);
			break;
		case CMD_NUMBER:
			switch(val) {
				case 0 ... 9:
					inputVal = inputVal*10+val;
					if (inputVal>99999)
						inputVal=99999;
					input->setVal(inputVal);
					break;
				case 10: // DEL
					inputVal /= 10;
					input->setVal(inputVal);
					break;
				default:
					;
			}
			break;
		case CMD_BAND:
			storeBand();
			setBand(val==0 ? inputVal: val);
			inputVal = 0;
			break;
		case CMD_STEP:
			step = val;
			filterGraph->setFreqStep(step);
			break;
		case CMD_WATERFALL_MIN:
			fftGraph->setMin(val);
			break;
		case CMD_WATERFALL_MAX:
			fftGraph->setMax(val);
			break;
		case CMD_SMETER_MODE:
			smtr->setMode(val);
			break;
		case CMD_RSSI:
			smtr->setRSSIVal((double)val/1000);
			break;
		case CMD_IN_LEVEL:
			smtr->setLevel(val);
			break;
		case CMD_POWER:
			smtr->setPowerVal((double)val/1000);
			break;
		case CMD_SWR:
			smtr->setSWRVal((double)val/1000);
			break;
		case CMD_ADC_OV:
			smtr->setOverflow(val==1);
			break;
		case CMD_GAIN:
		case CMD_ANT:
		case CMD_PREAMP:
			break;
		case CMD_TX:
			ptt = val;
			if (val) {
				setVal(CMD_SMETER_MODE, SMETER_LEVEL);
				smtr->setMode(SMETER_LEVEL);
			} else {
				setVal(CMD_SMETER_MODE, SMETER_RX);
				smtr->setMode(SMETER_RX);
			}
			break;
		case CMD_DISP_COLOR:
			fftGraph->settingsChanged(val);
			break;
		case CMD_VOLUME:
			volume = val;
			break;
		case CMD_AGC_DEC:
		case CMD_TX_POWER:
		case CMD_NB_LEVEL:
		case CMD_NOTCH:
		case CMD_INTERNAL:
			break;
		case CMD_ENCODER0:
			if (val==0)
				break;
			encSens = step > 50 ? 4:0; 
			encDelta += val;
			val = encDelta >> encSens;
			encDelta = (val+encDelta) & ((1<<encSens)-1);
			if (val<0) {
				freq = rxFreq;
				if ((freq % step) == 0)
					freq+= step*val;
				freq -= (freq % step);
			} else {
				freq = rxFreq + step*val;
				freq -= (freq % step);
			}
			setFreq(freq);
			break;
		case CMD_ENCODER1:
			if (val==0)
				break;
			button[select1ButtonIdx].button->pressed(val<0, true);
			break;
		case CMD_ENCODER2:
			if (val==0)
				break;
			button[select0ButtonIdx].button->pressed(val<0, true);
			break;
		case CMD_SELECT0:
			break;
		case CMD_SELECT1:
			button[select0ButtonIdx].button->setCmd(val);
			button[select0ButtonIdx].button->setVal(getVal(val));
			break;
		default:
			PDEBUG(ERR1, "Display: unhandled command: %s, par %i",CmdString[cmd],val);
			break;
	}
}


void Display_touch::storeMemory(int val) {
	if (val >= arraysize(mem))
		return;
	mem[val].name = QString("mem %1").arg(val+1);
	mem[val].mode = getVal(CMD_MODE);
	mem[val].rxFreq = rxFreq;
	mem[val].txFreq = txFreq;
	mem[val].filterHi = getVal(CMD_FILTER_RX_HI);
	mem[val].filterLo = getVal(CMD_FILTER_RX_LO);
	mem[val].preamp = getVal(CMD_PREAMP);
	mem[val].ant = getVal(CMD_ANT);
}

void Display_touch::setMemory(int val) {
	if (val >= arraysize(mem))
		return;
	displaySet(SRC_DISP, CMD_MODE, mem[val].mode);
	displaySet(SRC_DISP, CMD_RX_FREQ, mem[val].rxFreq);
	displaySet(SRC_DISP, CMD_TX_FREQ, mem[val].txFreq);
	displaySet(SRC_DISP, CMD_FILTER_RX_HI, mem[val].filterHi);
	displaySet(SRC_DISP, CMD_FILTER_RX_LO, mem[val].filterLo);
	displaySet(SRC_DISP, CMD_PREAMP, mem[val].preamp);
	displaySet(SRC_DISP, CMD_ANT, mem[val].ant);
}

void Display_touch::storeBand() {
	int curBand = getBand(rxFreq); 
	if (curBand < 0)
		return;
	memBand[curBand].name = QString("memBand %1").arg(curBand+1);
	memBand[curBand].mode = getVal(CMD_MODE);
	memBand[curBand].rxFreq = rxFreq;
	memBand[curBand].txFreq = txFreq;
	memBand[curBand].filterLo = getVal(CMD_FILTER_RX_LO);
	memBand[curBand].filterHi = getVal(CMD_FILTER_RX_HI);
	memBand[curBand].preamp = getVal(CMD_PREAMP);
	memBand[curBand].ant = getVal(CMD_ANT);
}

void Display_touch::setBand(int val) {
	if (val>=arraysize(memBand))
		return;
	displaySet(SRC_DISP, CMD_MODE, memBand[val].mode);
	displaySet(SRC_DISP, CMD_RX_FREQ, memBand[val].rxFreq);
	displaySet(SRC_DISP, CMD_TX_FREQ, memBand[val].txFreq);
	displaySet(SRC_DISP, CMD_FILTER_RX_HI, memBand[val].filterHi);
	displaySet(SRC_DISP, CMD_FILTER_RX_LO, memBand[val].filterLo);
	displaySet(SRC_DISP, CMD_PREAMP, memBand[val].preamp);
	displaySet(SRC_DISP, CMD_ANT, memBand[val].ant);
}

void Display_touch::setFFTSize(int val) {
	fftSize = val;
	window.clear();
	for (int i=0;i<fftSize;i++)
		window.push_back(0.5  - 0.5  * cos (2 * M_PI / (fftSize) * i));  // Hanning window

	fftwf_destroy_plan(plan);
	fftwf_free(in); 
	fftwf_free(out);

	in  = (fftwf_complex*) fftwf_malloc(sizeof(fftwf_complex) * fftSize);
	out = (fftwf_complex*) fftwf_malloc(sizeof(fftwf_complex) * fftSize);
	plan = fftwf_plan_dft_1d(fftSize, in, out, FFTW_FORWARD, FFTW_ESTIMATE);

	calcCicCorr();

	fftGraph->setFFTSize(fftSize);
	filterGraph->setFFTSize(fftSize);
}

void Display_touch::fftData(QByteArray rawData) {
	int i;
	int max=0;
	if (!update)
		return;

	for (i=0;i<fftSize;i++) {
		short t;
		t = *(short*)(rawData.data()+(i*4+0));
		if (t>max) max=t;
		in[i][0] = ((double)t) * window[i]/ MAX_SHORT;
		t = *(short*)(rawData.data()+(i*4+2));
		if (t>max) max=t;
		in[i][1] = ((double)t) * window[i]/ MAX_SHORT;

	}
	rawData.clear();
	fftwf_execute(plan);

	for (int i = 0; i < fftSize; i++){
		const double x = out[i][0];
		const double y = out[i][1];
		double tmp = sqrt(x*x + y*y);
		if (tmp==0)
			tmp = 1e-8;
		double v =	log10(tmp/fftSize);

		// cic1 verstaerkungen kompensieren
		if (fftSampRate > 64000)
			v+=fftWidthOffset;
		else
			v+=fftNearOffset;

		buf[i<fftSize/2 ? (int)(fftSize/2+i) : (int)(i-fftSize/2)] = v;
	}
	for (int i = 0; i < fftSize; i++)
		buf[i]-=cicCorr[i];

	fftGraph->fftDataReady(buf);
}

void Display_touch::smtrPressed(int,int) {
}

void Display_touch::freqChanged(int f) {
	static double shiftRemainder=0;
	int df = rxFreq-f;
	rxFreq = f; // - f % getVal(CMD_STEP) ;
	double vs = (double)df*fftSize/fftSampRate;

	shiftRemainder += vs-floor(vs);
	if (shiftRemainder >= 1) {
		vs += floor(shiftRemainder);
		shiftRemainder -= floor(shiftRemainder);
	}
	fftGraph->scrollVert(floor(vs));
	rxfreq->setVal(rxFreq);
	filterGraph->setFreq(rxFreq);
	filterGraph->setFilter(rxFreq, getVal(CMD_FILTER_RX_LO), getVal(CMD_FILTER_RX_HI), getVal(CMD_MODE));

	update = false;
	timer->start(400);
}

void Display_touch::updateOn() {
	timer->stop();
	update = true;
}

void Display_touch::buttonPressed(int id, int val) {
	displaySet(SRC_DISP, id,val);
}

void Display_touch::analogChanged(int id, int val) {
	displaySet(SRC_DISP, id,val);
}

void Display_touch::readSettings() {
	settings->beginGroup("display_touch");

	settings->beginReadArray("Mem");
	for (int i=0;i<arraysize(mem);i++) {
		settings->setArrayIndex(i);
		mem[i].mode = settings->value("mode",mem[i].mode).toInt();
		mem[i].rxFreq = settings->value("rxFreq",mem[i].rxFreq).toInt();
		mem[i].txFreq = settings->value("txFreq",mem[i].txFreq).toInt();
		mem[i].filterLo = settings->value("filterLo",mem[i].filterLo).toInt();
		mem[i].filterHi = settings->value("filterHi",mem[i].filterHi).toInt();
		mem[i].preamp = settings->value("preamp",mem[i].preamp).toInt();
		mem[i].ant = settings->value("ant",mem[i].ant).toInt();
	}
	settings->endArray();

	settings->beginReadArray("MemBand");
	for (int i=0;i<arraysize(memBand);i++) {
		settings->setArrayIndex(i);
		memBand[i].mode = settings->value("mode",memBand[i].mode).toInt();
		memBand[i].rxFreq = settings->value("rxFreq",memBand[i].rxFreq).toInt();
		memBand[i].txFreq = settings->value("txFreq",memBand[i].txFreq).toInt();
		memBand[i].filterLo = settings->value("filerLo",memBand[i].filterLo).toInt();
		memBand[i].filterHi = settings->value("filterHi",memBand[i].filterHi).toInt();
		memBand[i].preamp = settings->value("preamp",memBand[i].preamp).toInt();
		memBand[i].ant = settings->value("ant",memBand[i].ant).toInt();
	}
	settings->endArray();
	settings->endGroup();
}

void Display_touch::writeSettings() {

	settings->beginGroup("display_touch");

	settings->beginWriteArray("Mem");
	for (int i=0;i<arraysize(mem);i++) {
		settings->setArrayIndex(i);
		settings->setValue("mode", mem[i].mode);
		settings->setValue("rxFreq", mem[i].rxFreq);
		settings->setValue("txFreq", mem[i].txFreq);
		settings->setValue("filterLo", mem[i].filterLo);
		settings->setValue("filterHi", mem[i].filterHi);
		settings->setValue("preamp", mem[i].preamp);
		settings->setValue("ant", mem[i].ant);
	}
	settings->endArray();

	settings->beginWriteArray("MemBand");
	for (int i=0;i<arraysize(memBand);i++) {
		settings->setArrayIndex(i);
		settings->setValue("mode", memBand[i].mode);
		settings->setValue("rxFreq", memBand[i].rxFreq);
		settings->setValue("txFreq", memBand[i].txFreq);
		settings->setValue("filterLo", memBand[i].filterLo);
		settings->setValue("filterHi", memBand[i].filterHi);
		settings->setValue("preamp", memBand[i].preamp);
		settings->setValue("ant", memBand[i].ant);
	}
	settings->endArray();
	settings->endGroup();
	settings->setValue("Size",size());
}

void Display_touch::sendCmd(int cmd, int val) {
	//PDEBUG(MSG1, "<-- Display: %s, Par: %i",CmdString[cmd],val);
	emit command(SRC_DISP, cmd, val); 
}

void Display_touch::keyPressEvent(QKeyEvent *event) {
	int key = event->key();
	qDebug() << key;
	switch (key) {
		case Qt::Key_F1 ... Qt::Key_F12: 
			displaySet(SRC_DISP_KEY, CMD_MENU, key-Qt::Key_F1);
			break;
		case '0' ... '9': 
			displaySet(SRC_DISP_KEY, CMD_NUMBER, key-'0');
			break;
		case Qt::Key_Delete:
			displaySet(SRC_DISP_KEY, CMD_NUMBER, 10);
			break;
		case Qt::Key_Enter:
		case Qt::Key_Return:
			displaySet(SRC_DISP_KEY, CMD_INPUT_FREQ, 0);
			break;
		case Qt::Key_Plus:
			displaySet(SRC_DISP_KEY, CMD_FREQ_STEP_UP,0);
			break;
		case Qt::Key_Minus:
			displaySet(SRC_DISP_KEY, CMD_FREQ_STEP_DOWN, 0);
			break;
		case 'F':
			if (fullScreen)
				this->setWindowState(Qt::WindowNoState);
			else
				this->setWindowState(Qt::WindowFullScreen);
			fullScreen = ~fullScreen;
			break;
		case Qt::Key_Space:
			if (ptt) 
				displaySet(SRC_DISP_KEY, CMD_TX, 0);
			else
				displaySet(SRC_DISP_KEY, CMD_TX, 1);

			break;
		case Qt::Key_VolumeUp:
			if (volume<255) {
				volume++;
				displaySet(SRC_DISP_KEY, CMD_VOLUME, volume);
			}
			break;
		case Qt::Key_VolumeDown:
			if (volume>0) {
				volume--;
				displaySet(SRC_DISP_KEY, CMD_VOLUME, volume);
			}
			break;
	}
}
