#include <QObject>
#include <QSettings>
#include <fftw3.h>
#include "config.h"

#define NOTCH_FFT_SIZE	1024	

class Dsp : public QObject {
	public:
		Dsp(int);
		~Dsp();

		void rxAdd(double,double);	
		int mod(short in, unsigned char *out);
		void setMode(int);
		void setGain(double);
		void setAGCDec(double);
		void setSampleRate(int);
		void bufReset();
		void muteSignal(bool);
		double getAgc();
		double getSmtr();
		void setMicGain(double);
		void setVolume(double);
		void setTestTone(double,double,double,double);
		void setNotchFilter(double);
		double processNotch(double in);
		double processNotch1(double in);
		void setNotch(int);
		void setSquelch(int);
		short tone();

		short outBuf[1024];
		int bufPos;
	private:
		short double2short(double v);
		double short2double(short v);
		short demod(double re, double im, double gain);
		double agc(double, double);
		void averageSqrt(double re, double im);
		int mode;
		double agcDec, manualGain;
		double agcMax;
		int sampleRate;
		bool mute;
		int notch;
		double squelch;
		double re_l,im_l;
		double phase,sensitivity;
		double avSqrt;
		double mgain,micGain,volume;
		double tone1Freq, tone2Freq, tone1Level, tone2Level;
		double tone1Phase,tone2Phase;
		double cwTonePhase,cwTone;
		double txGainAttRate;
		int smtrAverage;
		int maxIn;
		QSettings *settings;
		int signCnt;
		double old_v;
		double notch_a1,notch_a2;
		fftwf_complex* in;
		fftwf_complex* out;
		fftwf_plan plan;
		double window[NOTCH_FFT_SIZE];

};

