QT       += core gui network
greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = rasdr

# CONFIG   -= app_bundle
CONFIG += qt debug_and_release

QMAKE_CXXFLAGS += -std=c++0x
TEMPLATE = app


win32 {
	DEFINES += WIN32
	CONFIG   += console
	LIBS += -L fftw -lfftw3-3
	LIBS +=  -lwinmm
	INCLUDEPATH += fftw
	SVNDEV = 0
	DEFINES += SVNREV=0 
}

unix:!android {
	DEFINES += UNIX 
	CONFIG   += console
	SVNDEV = $$system(svnversion)
	DEFINES += SVNREV=\'\"$$SVNDEV\"\'
	LIBS += -lfftw3f
	LIBS += -lasound
	#LIBS += -lwiringPi
	# QT += multimedia
} 

unix:android {
	QT += multimedia
	DEFINES += ANDROID
	SVNDEV = $$system(svnversion)
	DEFINES += SVNREV=\'\"$$SVNDEV\"\'
	LIBS += /home/stefan/projekte/sdr/rasdr/trunk/src/libfftw3f.a
} 

INCLUDEPATH += /usr/local/include/ 

SOURCES += main.cpp control.cpp hiqsdr.cpp firdes.cc
SOURCES += display_base.cpp display_touch.cpp display_lcd.cpp smeter.cpp clock.cpp
SOURCES += textbutton.cpp  numeric.cpp fftGraph.cpp filterGraph.cpp analog.cpp
SOURCES += lib.cpp dsp.cpp label.cpp sdrgraphicsitem.cpp

unix:!android {
	#SOURCES += keyreader.cpp audio.cpp
	#SOURCES += audioQt.cpp
	SOURCES += audio.cpp
}

unix:android {
	SOURCES += audioQt.cpp
}

win32 {
	SOURCES += audio_win32.cpp
}

HEADERS += control.h hiqsdr.h display_lcd.h display_touch.h display_base.h smeter.h clock.h
HEADERS += textbutton.h numeric.h fftGraph.h filterGraph.h analog.h label.h sdrgraphicsitem.h

unix:!android {
	#HEADERS += keyreader.h audio.h
	# HEADERS += audioQt.h
	HEADERS += audio.h
}

unix:android {
	HEADERS += audioQt.h
}

win32 {
	HEADERS += audio_win32.h
}

FORMS    += display_touch.ui

ANDROID_PACKAGE_SOURCE_DIR = $$PWD/android

OTHER_FILES += \
    android/AndroidManifest.xml

